#!/tmp/.ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZpErLZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZperl/bin/perl

use HTML::Template;
use ActiveState::Config qw( :path);
use PureMessage::Manager::Request qw($REQUEST %in);
use PureMessage::Manager::Config qw(%config);
use PureMessage::Manager::Lang;
use PureMessage::Manager::Response::Services::HTTPD;
use PureMessage::HTTPD::Config qw( %httpd_config );
use strict;

my %vars;
our %config;

my $r = $REQUEST->get_response( 'PureMessage::Manager::Response::Services::HTTPD');

$r->{debug} =0;

$r->add_help(text => "Help", tab => "locserv", page => "mgr_locserv_rpc_httpd_service" );

$r->title(text('httpd_configure_title'));
$r->addRestartDlg(type=>'httpd');

my $action = $in{'action'};

$action = 'save' if $in{'save'};
$action = 'edit' if $in{'edit'};

# revisit is always set when the form is submitted so this is the first view
# so if load isn't sent from the link to this page we should still have
# valid values
#
$in{'load'} = 1 if !$in{revisit};




# get template vars we always want
$vars{'ACTION'} = $action;

if ($action =~ /save/) {
    if ( !hasValidateErrors() ) {
         commitUpdatedDataToDisk();
    } 
} 

putEditPage();


### start of subs

sub putEditPage() {

    $vars{HEADER} = $r->ThemeSectionHeader( title=> text('httpd_edit_header'))->output(); 
    
    $vars{HOSTNAME} = $in{load} ? $httpd_config{'ServerName'} : $in{hostname};
    $vars{PORT} = $in{load} ? $httpd_config{'Port'} : $in{port};

    my $tb = $r->ToolBar(
                        buttons => [[ { type=>'image',text=>'Save',name=>'save',icon=>'save'},
                                      { type=>'image',text=>'Cancel',href=>'index.cgi',icon=>'cancel'},
                                   ]],
                        table=> [[1,3],['50%','50%']],
                      );
    $vars{FOOTER} = $r->ThemeSectionFooter(toolbar=>$tb)->output();

    $r->add_template( 'file'=>'tmpl/configure.html', 'data'=>\%vars );
    $r->send();

}

sub commitUpdatedDataToDisk {

    eval {
      my %values = ( 'Port' => $in{port} ? $in{port} : '',
                     'ServerName' => $in{hostname} ? $in{hostname} : '',
                   );
      PureMessage::HTTPD::Config::update(%values);
    };
    
    if ($@) {
        # config died, deal with it
        $r->raise_error('error_httpd_saving_conf',$@);
        $r->error_dlg();
        $r->send();
        exit;
    }

    $r->addInfoBox( msg => text('httpd_message_update_ok'));
    $r->log('Update HTTPD','','httpd', \%in);
}
sub hasValidateErrors {
     $in{port} = '' unless $in{port}; # validator won't check keys that don't exists in input
     $in{hostname} = '' unless $in{hostname}; # validator won't check keys that don't exists in input
                                              # so force this to exist
     $REQUEST->typedecl("port", "#value #int", "Port");
     $REQUEST->typedecl("hostname", "#value #str", "Hostname");
     my @v_errors = $REQUEST->validate(\%in);
     if (@v_errors) {
          $r->raise_error(join("<br>", @v_errors));
     }
    return $r->error() ? 1 : 0;
}





